#include <TypeToBytes.mqh> // https://www.mql5.com/ru/code/16280

#define OnTick OnTick2          // void OnTick( const string &Symb )
#define OnBookEvent OnBookEvent // void OnBookEvent( const string &Symb )

class TICK
{
private:
  MqlTick PrevTick;

public:
  const string Symb;

  TICK( const string sSymb) : Symb(sSymb)
  {
  }

  bool IsNew( const bool FlagRun = true )
  {
    MqlTick Tick;

    const bool Res = ::SymbolInfoTick(this.Symb, Tick) && (_R(Tick) != this.PrevTick);

    if (Res)
    {
      this.PrevTick = Tick;

      if (FlagRun)
        ::OnTick(this.Symb);
    }

    return(Res);
  }
};

class BOOKS
{
private:
  MqlBookInfo PrevBooks[];

public:
  const string Symb;

  BOOKS( const string sSymb) : Symb(sSymb)
  {
    ::MarketBookAdd(this.Symb);
  }

  ~BOOKS( void )
  {
    ::MarketBookRelease(this.Symb);
  }

  bool IsNew( const bool FlagRun = true )
  {
    MqlBookInfo Books[];

    const bool Res = ::MarketBookGet(this.Symb, Books) && (_R(Books) != this.PrevBooks);

    if (Res)
    {
      ::ArraySwap(Books, this.PrevBooks);

      if (FlagRun)
        ::OnBookEvent(this.Symb);
    }

    return(Res);
  }
};

template <typename T>
class NEWDATA
{
private:
  T* Data[];
  const int Amount;

public:
  NEWDATA( const string &Symbols[] ) : Amount(::ArrayResize(this.Data, ::ArraySize(Symbols)))
  {
    for (int i = 0; i < this.Amount; i++)
      this.Data[i] = new T(Symbols[i]);
  }

  ~NEWDATA( void )
  {
    for (int i = 0; i < this.Amount; i++)
      delete this.Data[i];
  }

  void Refresh( void )
  {
    for (int i = 0; i < this.Amount; i++)
      this.Data[i].IsNew();

    return;
  }
};